// Calculate.java

import java.awt.*;
import java.applet.*;
import java.awt.event.*;

public class Calculate extends Applet
{  public void init()
   {  setLayout(new BorderLayout(10,10));

      display = new TextField("0", 40);
      display.setEditable(false);
      display.setBackground( Color.gray );     
      display.setForeground( Color.cyan );

 
      selectcolor = new Choice();
      fontstyle = new Choice();

      p = new Panel();

      CalActionHandler j = new CalActionHandler(display);
      CalItemHandler k = new CalItemHandler(p,selectcolor,fontstyle,display);
  
      add("North", display);
      
      
      Panel o = new Panel();
      o.setLayout(new GridLayout(1, 4)); 
      Label l = new Label("Text color:",Label.CENTER);
      o.add(l);
 
      //fill the choice
      selectcolor.addItem("Cyan");
      selectcolor.addItem("Pink");
      selectcolor.addItem("Magenta");
      selectcolor.addItem("Yellow");
      selectcolor.addItem("Blue");
      selectcolor.addItem("Green");
      selectcolor.addItem("Red");
      selectcolor.addItemListener(k);
      o.add (selectcolor);

     Label l2 = new Label("Font style:",Label.CENTER);
     o.add(l2);
 
     //fill the choice
      fontstyle.addItem("Plain");
      fontstyle.addItem("Bold");
      fontstyle.addItem("Italic");
      fontstyle.addItemListener(k);
      o.add (fontstyle);
      add("South",o); 
        
 
      p.setLayout(new GridLayout(4, 6));
      for (int i = 0; i <= 4; i++){ 
      b=new Button("" + (char)('0'+i)); 
      b.addActionListener(j);
      p.add(b); 

      }
      b=new Button("C"); 
      b.addActionListener(j);
      p.add(b);

      for (int i = 5; i <= 9; i++){ 
      b=new Button("" + (char)('0'+i)); 
      b.addActionListener(j);
      p.add(b); 

      }

      b=new Button("M"); 
      b.addActionListener(j);
      p.add(b);
      b=new Button("+"); 
      b.addActionListener(j);
      p.add(b);
      b=new Button("-"); 
      b.addActionListener(j);
      p.add(b);
      b=new Button("*"); 
      b.addActionListener(j);
      p.add(b);
      b=new Button("/"); 
      b.addActionListener(j);
      p.add(b);
      b=new Button("="); 
      b.addActionListener(j);
      p.add(b);
      b=new Button("MR"); 
      b.addActionListener(j);
      p.add(b);
      b=new Button("."); 
      b.addActionListener(j);
      p.add(b);
      b=new Button("%"); 
      b.addActionListener(j);
      p.add(b);
      b=new Button("1/x"); 
      b.addActionListener(j);
      p.add(b);
      b=new Button("x^2"); 
      b.addActionListener(j);
      p.add(b);
      b=new Button("Sqrt"); 
      b.addActionListener(j);
      p.add(b);
      b=new Button("Del"); 
      b.addActionListener(j);
      p.add(b);


      
      p.setForeground( Color.cyan );
      p.setBackground( Color.black );
      add("Center", p);
   }
   
   
   private TextField display;
   private Choice selectcolor;
   private Choice fontstyle;
   private Panel p;
   private Button b;
}

class CalItemHandler implements ItemListener{
  CalItemHandler(Panel pp,Choice slct,Choice fs,TextField disp){
   display=disp;
   selectcolor=slct;
   fontstyle=fs;
   p=pp;

   }
  
  public void itemStateChanged(ItemEvent e){

     Choice choice=(Choice)e.getItemSelectable();

     Color c= display.getForeground();
     if (e.getItem().toString()=="Cyan")
     c= Color.cyan; 
     else if(e.getItem().toString()=="Pink")
     c = Color.pink;
     else if(e.getItem().toString()=="Magenta")
     c = Color.magenta;
     else if(e.getItem().toString()=="Yellow")
     c = Color.yellow;
     else if(e.getItem().toString()=="Blue")
     c = Color.blue;
     else if(e.getItem().toString()=="Green")
     c = Color.green;
     else if(e.getItem().toString()=="Red")
     c = Color.red;
     
     display.setForeground(c);
     p.setForeground(c);     
     int Fontstyle=(display.getFont()).getStyle();; 
     if (e.getItem().toString()=="Plain") 
        Fontstyle=Font.PLAIN;
     else if(e.getItem().toString()=="Bold")
        Fontstyle=Font.BOLD;
     else if (e.getItem().toString()=="Italic")
        Fontstyle=Font.ITALIC;
      Font currentfont = display.getFont();
      Font newfont = new Font(currentfont.getName(),Fontstyle,
      currentfont.getSize());
      display.setFont(newfont);
      p.setFont(newfont);  


 }  

   private TextField display;
   private Choice selectcolor;
   private Choice fontstyle;
   private Panel p;
  
}



class CalActionHandler implements ActionListener{

   CalActionHandler(TextField display1){display=display1;}
  
   public void actionPerformed(ActionEvent evt)
   {
        String s = (String) evt.getActionCommand();
         char ch = s.charAt(0);

         if (s.equals("%"))
             {

             double total1= Format.atof(display.getText())/100;
             display.setText("" + total1);
   
             }else

         if (s.equals("x^2"))
             {
                       
             
              double total1=Format.atof(display.getText())*
                     Format.atof(display.getText());
              display.setText("" + total1);

             }else  

          if (s.equals("1/x"))
             {
           

             double total1=(double)1/Format.atof(display.getText());
              display.setText("" + total1);
             }else

         if (s.equals("Sqrt"))
            {
  
            double total1=Math.sqrt(Format.atof(display.getText()));
            display.setText("" + total1);
            }else
 
         if (s.equals("C"))
             {
   
             total=0;
             display.setText("" + total);
             start = true; 
             }else         
         
         if (s.equals("M"))
            {
 
            M = Format.atof(display.getText());
            }else

         if (s.equals("MR"))
            {
  
            display.setText("" + M);
            start=false;
            }else

         if (s.equals("Del")&& !start)
            {
            String x = display.getText();
            int length = x.length();
            String y = x.substring(0 , length-1);
            display.setText("" + y);
            }else

             
         if (('0' <= ch) && (ch <= '9') || (ch =='.') )
         {  if (start) display.setText(s);
            else
            display.setText(display.getText() + s);
            start = false;
            }else
         {  if (start)
            {   
             if (s.equals("-")) 
               { display.setText(s); start =false; }
               
               else op = s;
            }
            else
            {
               calculate(Format.atof(display.getText()));
               op = s;
               start = true;
            }
         }
      
   }
   
   public void calculate(double n)
   {  if (op == "+") total += n;
      else if (op == "-") total -= n;
      else if (op == "*") total *= n;
      else if (op == "/") total /= n;
      else if (op == "%") total %= n;
      else if (op == "=") total = n;
      
      display.setText("" + total);
   }
   private double total = 0;
   private double M = 0;
   private String op = "=";
   private boolean start = true;
   private TextField display;

}
